affichebootstrap<-function(x,y,FOUT=FOUT,e,estimation,modele="None",
                  forme,degreformule,intercept=TRUE,
	          tabA1=rep("no",dimx),
                  tabA2=rep("no",dimx),
                  tabA3=rep("no",dimx),
	          tabA4=rep("no",dimx),
                  tabB1=array("no",dim=c(dimx,dimx)),
	          tabC1=array("no",dim=c(dimx,dimx,dimx)),
	          tabC2=array("no",dim=c(dimx,dimx)),
	          tabD1=array("no",dim=c(dimx,dim,dimx,dimx)),
	          tabD2=array("no",dim=c(dimx,dimx)),
	          tabD3=array("no",dim=c(dimx,dimx,dimx)),
	          tabD4=array("no",dim=c(dimx,dimx))){

#-----------------------------------------------------------------------
#Fonction permettant d'afficher les resultats du bootstrap             |
#----------------------------------------------------------------------|
#Arguments                                                             |
#obligatoires : x : matrice des variables d'entree                     |
#               y : variable de sortie                                 |
#               FOUT : nom du fichier ou inscrire les resultats        |
#               e : la longueur de la variable estimation              |
#               estimation : variable contenant les resultats du       |
#               bootstrap                                              |
#               modele: variable contenant le modele GLM calcule       |
#                 Par defaut : "None" signifie pas de modele GLM       |
#               forme : pour indiquer la facon dont on a cree la       |
#               formule de regression GLM                              |
#               degreformule : le degre de la formule de regression    |
#               si forme="creationformule"                             |
#               bootstrap                                              |
#               intercept : indique s'il y a une constante dans la     |
#               formule de regression si forme="maformule"             |
#               tabA1 : pour introduire les Vi dans "maformule"        |
#               tabA2 : pour introduire les Vi^2 dans "maformule"      |
#               tabA3 : pour introduire les Vi^3 dans "maformule"      |
#               tabA4 : pour introduire les Vi^4 dans "maformule"      |
#               tabB1 : pour introduire les ViVj dans "maformule"      |
#               tabC1 : pour introduire les ViVjVk dans "maformule"    |
#               tabC2 : pour introduire les Vi^2Vj dans "maformule"    |
#               tabD1 : pour introduire les ViVjVkVl dans "maformule"  |
#               tabD2 : pour introduire les Vi^3 dans "maformule"      |
#               tabD3 : pour introduire les Vi^2VjVk dans "maformule"  |
#               tabD4 : pour introduire les Vi^2Vj^2 dans "maformule"  |
#----------------------------------------------------------------------|
#Sortie : la fonction affiche les resultats dans le fichier            |
#res-SURFER.out qui se trouve dans le repertoire de travail            |
#----------------------------------------------------------------------|
#      Auteur : A. Ducellier et B. Iooss                               |
#----------------------------------------------------------------------|

write("-----------------",file=FOUT)
write("| ------------- |",file=FOUT)
write("| | Bootstrap | |",file=FOUT)
write("| ------------- |",file=FOUT)
write("-----------------",file=FOUT)
write(" ",file=FOUT)

if(e==1){
  write(c("Il reste",estimation[1],"echantillons bootstrap"),ncolumns=3,file=FOUT)
  write("Il faut reduire le nombre de coefficients dans la formule de regression",file=FOUT)
  write("ou modifier la taille des echantillons boostrap",file=FOUT)
  write("ou alors le modele est vraiment trop mauvais (-> rien a faire)",file=FOUT)
  write(" ",file=FOUT)}

else{

  write(c("Il reste",estimation[e],"echantillons bootstrap"),ncolumns=3,file=FOUT)
  write(" ",file=FOUT)

#-----------------------------------------------------------
# Modele GLM
#-----------------------------------------------------------

  if (is.null(modele$coefficients) == FALSE){

# Nombre de coefficients
#  if (is.null(modele$null.deviance) == TRUE) l<-modele$ncomp+1 #PLS
  l<-0.25*(length(summary(modele)$coefficients)) #GLM

#----------------------------
#Affichage des coefficients |
#----------------------------

  write("-------------------------------",file=FOUT)
  write("| Estimation des coefficients |",file=FOUT)
  write("-------------------------------",file=FOUT)
  write(" ",file=FOUT)

#--------------------------------------
#Affichage si forme="creationformule" |
#--------------------------------------

  if(forme=="creationformule"){

#-----------------------------
#Affichage si degreformule=1 |
#-----------------------------

    if(degreformule==1){
    d<-dim(x)[2]

    write("            Moyenne   Ecart-type   Intervalle de confiance a 90%",file=FOUT)
    write(" ",file=FOUT)

#Affichage de la constante
    write(c("Intercept"," ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=6,file=FOUT)
    write(" ",file=FOUT)
    if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
            l <- l-1}
    else estimation<-estimation[5:49]

#Affichage des Vi
    for(i in 1:d){
       write(c("V",i,"       ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=7,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }}

#-----------------------------
#Affichage si degreformule=2 |
#-----------------------------

    if(degreformule==2){
    d<-dim(x)[2]

    write("            Moyenne   Ecart-type   Intervalle de confiance a 90%",file=FOUT)
    write(" ",file=FOUT)

#Affichage de la constante
    write(c("Intercept"," ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=6,file=FOUT)
    write(" ",file=FOUT)
    if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
            l <- l-1}
    else estimation<-estimation[5:49]

#Affichage des Vi
    for(i in 1:d){
       write(c("V",i,"       ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=7,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]}

#Affichage des Vi^2
    for(i in 1:d){
       write(c("V",i,"^2","    ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des ViVj
    if (d>1){
      for(i in 1:(d-1)){
        for(j in (i+1):d){
          write(c("V",i,"V",j,"   ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=9,file=FOUT)
          write(" ",file=FOUT)
          if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                  l <- l-1}
          else estimation<-estimation[5:49]
          }}}}

#-----------------------------
#Affichage si degreformule=3 |
#-----------------------------

    if(degreformule==3){
    d<-dim(x)[2]

    write("              Moyenne   Ecart-type   Intervalle de confiance a 90%",file=FOUT)
    write(" ",file=FOUT)

#Affichage de la constante
    write(c("Intercept    ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=5,file=FOUT)
    write(" ",file=FOUT)
    if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
            l <- l-1}
    else estimation<-estimation[5:49]

#Affichage des Vi
    for(i in 1:d){
       write(c("V",i,"         ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=7,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des Vi^2
    for(i in 1:d){
       write(c("V",i,"^2","      ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des Vi^3
    for(i in 1:d){
       write(c("V",i,"^3","      ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des ViVj
    if (d>1){
      for(i in 1:(d-1)){
        for(j in (i+1):d){
          write(c("V",i,"V",j,"     ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=9,file=FOUT)
          write(" ",file=FOUT)
          if(l>1){estimationf<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                  l <- l-1}
          else estimation<-estimation[5:49]
          }}}

#Affichage des Vi^2Vj
    if (d>1){
      for(i in 1:d){
       for(j in 1:d){
          if(i!=j){
             write(c("V",i,"^2","V",j,"  ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=10,file=FOUT)
             write(" ",file=FOUT)
             if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                     l <- l-1}
        	 else estimation<-estimation[5:49]
             }}}}

#Affichage des ViVjVk
    if (d>2){
      for(i in 1:(d-2)){
       for(j in (i+1):(d-1)){
          for(k in (j+1):d){
             write(c("V",i,"V",j,"V",k," ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=11,file=FOUT)
        	 write(" ",file=FOUT)
             if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                     l <- l-1}
	     else estimation<-estimation[5:49]
             }
          }
       }
    }
    }

#-----------------------------
#Affichage si degreformule=4 |
#-----------------------------

    if(degreformule==4){
    d<-dim(x)[2]

    write("                  Moyenne   Ecart-type   Intervalle de confiance a 90%",file=FOUT)
    write(" ",file=FOUT)

#Affichage de la constante
    write(c("Intercept","       ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=6,file=FOUT)
    write(" ",file=FOUT)
    if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
            l <- l-1}
else estimation<-estimation[5:49]

#Affichage des Vi
    for(i in 1:d){
       write(c("V",i,"             ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=7,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des Vi^2
    for(i in 1:d){
       write(c("V",i,"^2","          ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des Vi^3
    for(i in 1:d){
       write(c("V",i,"^3","          ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des Vi^4
    for(i in 1:d){
       write(c("V",i,"^4","          ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
       write(" ",file=FOUT)
       if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
               l <- l-1}
       else estimation<-estimation[5:49]
       }

#Affichage des ViVj
    if (d>1){
      for(i in 1:(d-1)){
       for(j in (i+1):d){
          write(c("V",i,"V",j,"         ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=9,file=FOUT)
          write(" ",file=FOUT)
          if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                  l <- l-1}
          else estimation<-estimation[5:49]
          }
       }
    }

#Affichage des Vi^2Vj
    if (d>1){
      for(i in 1:d){
       for(j in 1:d){
          if(i!=j){
             write(c("V",i,"^2","V",j,"      ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=10,file=FOUT)
             write(" ",file=FOUT)
        	 if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                     l <- l-1}
        	 else estimation<-estimation[5:49]
             }
          }
       }
    }

#Affichage des Vi^2Vj^2
    if (d>1){
      for(i in 1:(d-1)){
       for(j in (i+1):d){
          write(c("V",i,"^2","V",j,"^2","   ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=11,file=FOUT)
          write(" ",file=FOUT)
          if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                  l <- l-1}
          else estimation<-estimation[5:49]
          }
       }
    }
 
#Affichage des Vi^3Vj
    if (d>1){
      for(i in 1:d){
       for(j in 1:d){
          if(i!=j){
             write(c("V",i,"^3","V",j,"      ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=10,file=FOUT)
             write(" ",file=FOUT)
        	 if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                     l <- l-1}
        	 else estimation<-estimation[5:49]
             }
          }
       }
    }

#Affichage des ViVjVk
    if (d>2){
      for(i in 1:(d-2)){
       for(j in (i+1):(d-1)){
          for(k in (j+1):d){
             write(c("V",i,"V",j,"V",k,"     ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=11,file=FOUT)
             write(" ",file=FOUT)
        	 if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                     l <- l-1}
        	 else estimation<-estimation[5:49]
             }
          }
       }
    }

#Affichage des Vi^2VjVk
    if (d>2){
      for(i in 1:d){
       for(j in 1:(d-1)){
          for(k in (j+1):d){
             if((i!=j)&(i!=k)){
        	    write(c("V",i,"^2","V",j,"V",k,"  ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=12,file=FOUT)
                write(" ",file=FOUT)
        	    if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                        l <- l-1}
        	    else estimation<-estimation[5:49]
                }
              }
          }
       }
    }

#Affichage des ViVjVkVL
    if (d>3){
      for(i in 1:(d-3)){
       for(j in (i+1):(d-2)){
          for(k in (j+1):(d-1)){
             for(L in (k+1):d){
        	    write(c("V",i,"V",j,"V",k,"V",L," ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=13,file=FOUT)
                write(" ",file=FOUT)
        	    if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                        l <- l-1}
                else estimation<-estimation[5:49]
                }
        	 }
          }
       }
    }   
    }

  }

#---------------------------------
# Affichage si forme="maformule" |
#---------------------------------

  if(forme=="maformule"){

  write("                  Moyenne   Ecart-type   Intervalle de confiance a 90%",file=FOUT)
  write(" ",file=FOUT)

#Affichage de la constante
  if(intercept==TRUE){
     write(c("Intercept","       ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=6,file=FOUT)
     write(" ",file=FOUT)
     if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
             l <- l-1}
     else estimation<-estimation[5:49]
     }

#Boucle pour prendre les Vi
  for(i in 1:dimx){
   if (tabA1[i]=="yes"){
      write(c("V",i,"             ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=7,file=FOUT)
      write(" ",file=FOUT)
      if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
              l <- l-1}
      else estimation<-estimation[5:49]
      }
   }

#Boucle pour prendre les Vi^2
  for(i in 1:dimx){
     if (tabA2[i]=="yes"){
        write(c("V",i,"^2","          ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
        write(" ",file=FOUT)
        if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                l <- l-1}
        else estimation<-estimation[5:49]
        }
     }

#Boucle pour prendre les Vi^3
  for(i in 1:dimx){
     if (tabA3[i]=="yes"){
        write(c("V",i,"^3","          ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
        write(" ",file=FOUT)
        if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                l <- l-1}
        else estimation<-estimation[5:49]
        }
     }

#Boucle pour prendre les Vi^4
  for(i in 1:dimx){
     if (tabA4[i]=="yes"){
        write(c("V",i,"^4","          ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=8,file=FOUT)
        write(" ",file=FOUT)
        if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                l <- l-1}
        else estimation<-estimation[5:49]
        }
     }

#Boucle pour prendre les ViVj
  if(dimx>1){for(i in 1:(dimx-1)){
                for(j in (i+1):dimx){
                   if (tabB1[i,j]=="yes"){
                      write(c("V",i,"V",j,"         ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=9,file=FOUT)
                      write(" ",file=FOUT)
                      if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                              l <- l-1}
	              else estimation<-estimation[5:49]
                      }
	  	 }
	        }
  }

#Boucle pour prendre les Vi^2Vj
  if(dimx>1){for(i in 1:dimx){
                for(j in 1:dimx){
                   if(tabC2[i,j]=="yes"){
                     if (i!=j){
	                write(c("V",i,"^2","V",j,"      ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=10,file=FOUT)
                        write(" ",file=FOUT)
                        if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                                l <- l-1}
		        else estimation<-estimation[5:49]
                        }
                     }
                  }
	      }
  }

#Boucle pour prendre les Vi^3Vj
  if(dimx>1){for(i in 1:dimx){
                for(j in 1:dimx){
                   if (tabD2[i,j]=="yes"){
                      if (i!=j){
	                 write(c("V",i,"^3","V",j,"      ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=10,file=FOUT)
                         write(" ",file=FOUT)
                         if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                                 l <- l-1}
		         else estimation<-estimation[5:49]
                         }
                      }
                   }
	        }
  }

#Boucle pour prendre les Vi^2Vj^2
  if(dimx>1){for(i in 1:(dimx-1)){
                for(j in (i+1):dimx){
                   if (tabD4[i,j]=="yes"){
                      write(c("V",i,"^2","V",j,"^2","   ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=11,file=FOUT)
                      write(" ",file=FOUT)
                      if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                              l <- l-1}
		      else estimation<-estimation[5:49]
                      }
                   }
	        }
  }

#Boucle pour prendre les ViVjVk
  if(dimx>2){for(i in 1:(dimx-2)){
                for(j in (i+1):(dimx-1)){
                   for(k in (j+1):dimx){
                      if (tabC1[i,j,k]=="yes"){
	                 write(c("V",i,"V",j,"V",k,"     ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=11,file=FOUT)
                         write(" ",file=FOUT)
                         if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                                 l <- l-1}
		         else estimation<-estimation[5:49]
                         }
                      }
                   }
                }
  }

#Boucle pour prendre les Vi^2VjVk
  if(dimx>2){for(i in 1:dimx){
                for(j in 1:(dimx-1)){
                   for(k in (j+1):dimx){
	              if (tabD3[i,j,k]=="yes"){
	                 if ((i!=j)&(i!=k)){
	                    write(c("V",i,"^2","V",j,"V",k,"  ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=12,file=FOUT)
                            write(" ",file=FOUT)
		  	    if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                                    l <- l-1}
		            else estimation<-estimation[5:49]
                            }
                         }
                      }
                   }
	        }
  }

#Boucle pour prendre les ViVjVkVL
  if(dimx>3){for(i in 1:(dimx-3)){
                for(j in (i+1):(dimx-2)){
                   for(k in (j+1):(dimx-1)){
                      for(l in (k+1):dimx){
	                 if (tabD1[i,j,k,l]=="yes"){
		            write(c("V",i,"V",j,"V",k,"V",l," ",estimation[c(1,l+1,2*l+1,3*l+1)]),ncolumns=13,file=FOUT)
                            write(" ",file=FOUT)
                            if(l>1){estimation<-estimation[c(2:l,(l+2):(2*l),(2*l+2):(3*l),(3*l+2):(4*l+45))]
                                    l <- l-1}
		            else estimation<-estimation[5:49]
                           }}}}}}
  }
}

#-----------------------------------
#Affichage des criteres de qualite|
#-----------------------------------

i<-1
ncr<-11 # nombre de criteres

write("-------------------------------------------------",file=FOUT)
write("  Estimation des criteres de qualite (prediction)",file=FOUT)
write("-------------------------------------------------",file=FOUT)
write(" ",file=FOUT)

write("                              Moyenne   Ecart-type   Intervalle de confiance a 90%",file=FOUT)
write(" ",file=FOUT)

write(c("Q2                              ",estimation[c(i,i+1*ncr,i+2*ncr,i+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Q2 ajuste                       ",estimation[c(i+1,i+1+1*ncr,i+1+2*ncr,i+1+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MSE                             ",estimation[c(i+2,i+2+1*ncr,i+2+2*ncr,i+2+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("NMSE                            ",estimation[c(i+3,i+3+1*ncr,i+3+2*ncr,i+3+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("SMSE                            ",estimation[c(i+4,i+4+1*ncr,i+4+2*ncr,i+4+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MAE                             ",estimation[c(i+5,i+5+1*ncr,i+5+2*ncr,i+5+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais                           ",estimation[c(i+6,i+6+1*ncr,i+6+2*ncr,i+6+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais normalise                 ",estimation[c(i+7,i+7+1*ncr,i+7+2*ncr,i+7+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu maximal                  ",estimation[c(i+8,i+8+1*ncr,i+8+2*ncr,i+8+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en moyenne       ",estimation[c(i+9,i+9+1*ncr,i+9+2*ncr,i+9+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en ecart-type    ",estimation[c(i+10,i+10+1*ncr,i+10+2*ncr,i+10+3*ncr)]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)}

}
