affichecontributions<-function(x,y,FOUT,modeleGLM,forme,
                      degreformule,idc,cor,effet,pourcentages.effet,
		      residus,pourcentage.residus,
                      intercept=TRUE,
	              tabA1=rep("no",dim(x)[2]),
                      tabA2=rep("no",dim(x)[2]),
                      tabA3=rep("no",dim(x)[2]),
	              tabA4=rep("no",dim(x)[2]),
                      tabB1=array("no",dim=c(dim(x)[2],dim(x)[2])),
	              tabC1=array("no",dim=c(dim(x)[2],dim(x)[2],dim(x)[2])),
	              tabC2=array("no",dim=c(dim(x)[2],dim(x)[2])),
	              tabD1=array("no",dim=c(dim(x)[2],dim,dim(x)[2],dim(x)[2])),
	              tabD2=array("no",dim=c(dim(x)[2],dim(x)[2])),
	              tabD3=array("no",dim=c(dim(x)[2],dim(x)[2],dim(x)[2])),
	              tabD4=array("no",dim=c(dim(x)[2],dim(x)[2]))
	              ){
		      
#------------------------------------------------------------------------
#Fonction permettant d'afficher les resultats du calcul des             |
#contributions des effets                                               |
#-----------------------------------------------------------------------|
#Arguments                                                              |
#obligatoires : x : la matrice des variables d'entree                   |
#               y : la variable de sortie                               |
#               FOUT : le nom du fichier ou inscrire les resultats      |
#               forme : indique la facon dont on a cree la formule      |
#               de regression                                           |
#               degreformule : le degre de la formule de regression si  |
#               forme="creationformule"                                 |
#               idc : variable contenant l'indice de conditionnement    |
#               de la matrice de correlations des effets                |
#               cor : variable contenant la matrice de correlation des  |
#               effets                                                  |
#               effet : variable contenant les valeurs des              |
#               contributions des effets                                |
#               pourcentages.effet : variable contenant les pourcentages|
#               correspondant                                           |
#               residus : variable contenant la valeur de la            |
#               contribution des residus                                |
#               pourcentage.residus : variable contenant le pourcentage |
#               correspondant                                           |
#               intercept : indique s'il y a une constante dans la      |
#               formule de regression si forme="maformule"              |
#               tabA1 : pour introduire les Vi dans "maformule"         |
#               tabA2 : pour introduire les Vi^2 dans "maformule"       |
#               tabA3 : pour introduire les Vi^3 dans "maformule"       |
#               tabA4 : pour introduire les Vi^4 dans "maformule"       |
#               tabB1 : pour introduire les ViVj dans "maformule"       |
#               tabC1 : pour introduire les ViVjVk dans "maformule"     |
#               tabC2 : pour introduire les Vi^2Vj dans "maformule"     |
#               tabD1 : pour introduire les ViVjVkVl dans "maformule"   |
#               tabD2 : pour introduire les Vi^3 dans "maformule"       |
#               tabD3 : pour introduire les Vi^2VjVk dans "maformule"   |
#               tabD4 : pour introduire les Vi^2Vj^2 dans "maformule"   |
#-----------------------------------------------------------------------|
#Sortie : la fonction inscrit les resultats dans le fichier             |
#res-SURFER.out qui se trouve dans le repertoire de travail             |
#-----------------------------------------------------------------------|
#      Auteurs : A. Ducelier et B. Iooss                                |
#-----------------------------------------------------------------------|

d<-dim(x)[2]

write("--------------------------------",file=FOUT)
write("| ---------------------------- |",file=FOUT)
write("| | Contributions des effets | |",file=FOUT)
write("| ---------------------------- |",file=FOUT)
write("--------------------------------",file=FOUT)
write(" ",file=FOUT)

#--------------------------------------
#Affichage si forme="creationformule" |
#--------------------------------------

if(forme=="creationformule"){

l<-length(modeleGLM$coefficients)
if(l<3){

write("           Contributions   Pourcentages",file=FOUT)
write(" ",file=FOUT)
write(c("Effet     ",effet,pourcentages.effet,"%"),ncolumns=4,file=FOUT)
write(" ",file=FOUT)
write(c("Residus   ",residus,pourcentage.residus,"%"),ncolumns=4,file=FOUT)
write(" ",file=FOUT)

}

else{

#-----------------------------
#Affichage si degreformule=1 |
#-----------------------------

if(degreformule==1){

l<-length(effet)

write("            Contributions   Pourcentages",file=FOUT)
write(" ",file=FOUT)

#Affichage des contributions des Vi
for(i in 1:d){
   write(c("V",i,"       ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=7,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des residus
write(c("Residus    ",residus,"   ",pourcentage.residus,"%"),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
}

#-----------------------------
#Affichage si degreformule=2 |
#-----------------------------

if(degreformule==2){
  
l<-length(effet)

write("            Contributions   Pourcentages",file=FOUT)
write(" ",file=FOUT)

#Affichage des contributions des Vi
for(i in 1:d){
   write(c("V",i,"       ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=7,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des Vi^2
for(i in 1:d){
   write(c("V",i,"^2","    ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des ViVj
if (d>1){
  for(i in 1:(d-1)){
    for(j in (i+1):d){
      write(c("V",i,"V",j,"   ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=9,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }
}

#Affichage des contributions des residus
write(c("Residus    ",residus,"   ",pourcentage.residus,"%"),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
   
}

#-----------------------------
#Affichage si degreformule=3 |
#-----------------------------

if(degreformule==3){

l<-length(effet)

write("              Contributions   Pourcentages",file=FOUT)
write(" ",file=FOUT)

#Affichage des contributions des Vi
for(i in 1:d){
   write(c("V",i,"         ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=7,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des Vi^2
for(i in 1:d){
   write(c("V",i,"^2","      ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des Vi^3
for(i in 1:d){
   write(c("V",i,"^3","      ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des ViVj
if (d>1){
  for(i in 1:(d-1)){
    for(j in (i+1):d){
      write(c("V",i,"V",j,"     ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=9,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }
}

#Affichage des contributions des Vi^2Vj
if (d>1){
  for(i in 1:d){
    for(j in 1:d){
      if(i!=j){
         write(c("V",i,"^2","V",j,"  ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=10,file=FOUT)
	 write(" ",file=FOUT)
         effet<-effet[2:l]
	 pourcentages.effet<-pourcentages.effet[2:l]
         l<-length(effet)
         }
      }
   }
}

#Affichage des contributions des ViVjVk
if (d>2){
  for(i in 1:(d-2)){
    for(j in (i+1):(d-1)){
      for(k in (j+1):d){
         write(c("V",i,"V",j,"V",k," ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=11,file=FOUT)
	 write(" ",file=FOUT)
         effet<-effet[2:l]
	 pourcentages.effet<-pourcentages.effet[2:l]
         l<-length(effet)
         }
      }
   }
}

#Affichage des contributions des residus
write(c("Residus      ",residus,"   ",pourcentage.residus,"%"),ncolumns=5,file=FOUT)
write(" ",file=FOUT)

}

#-----------------------------
#Affichage si degreformule=4 |
#-----------------------------

if(degreformule==4){

l<-length(effet)

write("                  Contributions   Pourcentages",file=FOUT)
write(" ",file=FOUT)

#Affichage des contributions des Vi
for(i in 1:d){
   write(c("V",i,"             ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=7,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des Vi^2
for(i in 1:d){
   write(c("V",i,"^2","          ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des Vi^3
for(i in 1:d){
   write(c("V",i,"^3","          ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des Vi^4
for(i in 1:d){
   write(c("V",i,"^4","          ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
   write(" ",file=FOUT)
   effet<-effet[2:l]
   pourcentages.effet<-pourcentages.effet[2:l]
   l<-length(effet)
   }

#Affichage des contributions des ViVj
if (d>1){
 for(i in 1:(d-1)){
   for(j in (i+1):d){
      write(c("V",i,"V",j,"         ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=9,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }
}

#Affichage des contributions des Vi^2Vj
if (d>1){
  for(i in 1:d){
    for(j in 1:d){
      if(i!=j){
         write(c("V",i,"^2","V",j,"      ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=10,file=FOUT)
         write(" ",file=FOUT)
	 effet<-effet[2:l]
	 pourcentages.effet<-pourcentages.effet[2:l]
         l<-length(effet)
         }
      }
   }
}

#Affichage des contributions des Vi^2Vj^2
if (d>2){
  for(i in 1:(d-1)){
    for(j in (i+1):d){
      write(c("V",i,"^2","V",j,"^2","   ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=11,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }
}

#Affichage des contributions des Vi^3Vj
if (d>1){
  for(i in 1:d){
    for(j in 1:d){
      if(i!=j){
         write(c("V",i,"^3","V",j,"      ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=10,file=FOUT)
         write(" ",file=FOUT)
	 effet<-effet[2:l]
	 pourcentages.effet<-pourcentages.effet[2:l]
         l<-length(effet)
         }
      }
   }
}

#Affichage des contributions des ViVjVk
if (d>2){
  for(i in 1:(d-2)){
    for(j in (i+1):(d-1)){
      for(k in (j+1):d){
         write(c("V",i,"V",j,"V",k,"     ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=11,file=FOUT)
         write(" ",file=FOUT)
	 effet<-effet[2:l]
	 pourcentages.effet<-pourcentages.effet[2:l]
         l<-length(effet)
         }
      }
   }
}

#Affichage des Vi^2VjVk
if (d>2){
  for(i in 1:d){
    for(j in 1:(d-1)){
      for(k in (j+1):d){
         if((i!=j)&(i!=k)){
	    write(c("V",i,"^2","V",j,"V",k,"  ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=12,file=FOUT)
            write(" ",file=FOUT)
	    effet<-effet[2:l]
	    pourcentages.effet<-pourcentages.effet[2:l]
            l<-length(effet)
            }
	 }
      }
   }
}

#Affichage des ViVjVkVL
if (d>3){
  for(i in 1:(d-3)){
    for(j in (i+1):(d-2)){
      for(k in (j+1):(d-1)){
         for(L in (k+1):d){
	    write(c("V",i,"V",j,"V",k,"V",L," ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=13,file=FOUT)
            write(" ",file=FOUT)
	    effet<-effet[2:l]
	    pourcentages.effet<-pourcentages.effet[2:l]
            l<-length(effet)
            }
	 }
      }
   }
}

#Affichage des contributions des residus
write(c("Residus          ",residus,"   ",pourcentage.residus,"%"),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
     
}

}

}

#--------------------------------
#Affichage si forme="maformule" |
#--------------------------------

if(forme=="maformule"){

l<-length(modeleGLM$coefficients)
if(((intercept==TRUE)&(l<3))|((intercept==FALSE)&(l==1))){

write("           Contributions   Pourcentages",file=FOUT)
write(" ",file=FOUT)
write(c("Effet     ",effet,pourcentages.effet,"%"),ncolumns=4,file=FOUT)
write(" ",file=FOUT)
write(c("Residus   ",residus,pourcentage.residus,"%"),ncolumns=4,file=FOUT)
write(" ",file=FOUT)

}

else{

l<-length(effet)

write("                  Contributions   Pourcentages",file=FOUT)
write(" ",file=FOUT)

#Boucle pour prendre les contributions des Vi
for(i in 1:d){
   if (tabA1[i]=="yes"){
      write(c("V",i,"             ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=7,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }

#Boucle pour prendre les contributions des Vi^2
for(i in 1:d){
   if (tabA2[i]=="yes"){
      write(c("V",i,"^2","          ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }

#Boucle pour prendre les contributions des Vi^3
for(i in 1:d){
   if (tabA3[i]=="yes"){
      write(c("V",i,"^3","          ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }

#Boucle pour prendre les contributions des Vi^4
for(i in 1:d){
   if (tabA4[i]=="yes"){
      write(c("V",i,"^4","          ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=8,file=FOUT)
      write(" ",file=FOUT)
      effet<-effet[2:l]
      pourcentages.effet<-pourcentages.effet[2:l]
      l<-length(effet)
      }
   }

#Boucle pour prendre les contributions des ViVj
if(d>1){for(i in 1:(d-1)){
              for(j in (i+1):d){
                 if (tabB1[i,j]=="yes"){
                    write(c("V",i,"V",j,"         ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=9,file=FOUT)
                    write(" ",file=FOUT)
                    effet<-effet[2:l]
		    pourcentages.effet<-pourcentages.effet[2:l]
                    l<-length(effet)
                    }
		 }
	      }
}

#Boucle pour prendre les contributions des Vi^2Vj
if(d>1){for(i in 1:d){
              for(j in 1:d){
                 if(tabC2[i,j]=="yes"){
                   if (i!=j){
	              write(c("V",i,"^2","V",j,"      ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=10,file=FOUT)
                      write(" ",file=FOUT)
                      effet<-effet[2:l]
		      pourcentages.effet<-pourcentages.effet[2:l]
                      l<-length(effet)
                      }
                   }
                }
	    }
}

#Boucle pour prendre les contributions des Vi^3Vj
if(d>1){for(i in 1:d){
              for(j in 1:d){
                 if (tabD2[i,j]=="yes"){
                    if (i!=j){
	               write(c("V",i,"^3","V",j,"      ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=10,file=FOUT)
                       write(" ",file=FOUT)
                       effet<-effet[2:l]
		       pourcentages.effet<-pourcentages.effet[2:l]
		       l<-length(effet)
                       }
                    }
                 }
	      }
}

#Boucle pour prendre les contributions des Vi^2Vj^2
if(d>1){for(i in 1:(d-1)){
              for(j in (i+1):d){
                 if (tabD4[i,j]=="yes"){
                    write(c("V",i,"^2","V",j,"^2","   ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=11,file=FOUT)
                    write(" ",file=FOUT)
                    effet<-effet[2:l]
		    pourcentages.effet<-pourcentages.effet[2:l]
                    l<-length(effet)
                    }
                 }
	      }
}

#Boucle pour prendre les contributions des ViVjVk
if(d>2){for(i in 1:(d-2)){
              for(j in (i+1):(d-1)){
                 for(k in (j+1):d){
                    if (tabC1[i,j,k]=="yes"){
	               write(c("V",i,"V",j,"V",k,"     ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=11,file=FOUT)
                       write(" ",file=FOUT)
                       effet<-effet[2:l]
		       pourcentages.effet<-pourcentages.effet[2:l]
                       l<-length(effet)
                       }
                    }
                 }
              }
}

#Boucle pour prendre les Vi^2VjVk
if(d>2){for(i in 1:d){
              for(j in 1:(d-1)){
                 for(k in (j+1):d){
	            if (tabD3[i,j,k]=="yes"){
	               if ((i!=j)&(i!=k)){
	                  write(c("V",i,"^2","V",j,"V",k,"  ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=12,file=FOUT)
                          write(" ",file=FOUT)
                          effet<-effet[2:l]
			  pourcentages.effet<-pourcentages.effet[2:l]
			  l<-length(effet)
                          }
                       }
                    }
                 }
	      }
}

#Boucle pour prendre les ViVjVkVL
if(d>3){for(i in 1:(d-3)){
              for(j in (i+1):(d-2)){
                 for(k in (j+1):(d-1)){
                    for(L in (k+1):d){
	               if (tabD1[i,j,k,L]=="yes"){
		          write(c("V",i,"V",j,"V",k,"V",L," ",effet[1],"   ",pourcentages.effet[1],"%"),ncolumns=13,file=FOUT)
                          write(" ",file=FOUT)
                          effet<-effet[2:l]
			  pourcentages.effet<-pourcentages.effet[2:l]
                          l<-length(effet)
                          }
	               }
                    }
                 }
              }
}

#Affichage des contributions des resultats
write(c("Residus          ",residus,"   ",pourcentage.residus,"%"),ncolumns=5,file=FOUT)
write(" ",file=FOUT)

}

}

#---------------------------------------------------
#Affichage de la matrice de correlation des effets |
#---------------------------------------------------

if(is.na(cor[1])==FALSE){

write("-------------------------------------",file=FOUT)
write("| Matrice de correlation des effets |",file=FOUT)
write("-------------------------------------",file=FOUT)
write(" ",file=FOUT)

nom<-dimnames(summary(modeleGLM)$coefficients)[[1]]
format(nom)
ln<-length(nom)

if(forme=="maformule"){if(intercept==TRUE){nom<-nom[2:ln]
                                           ln<-length(nom)
		                           }
		       }
else{nom<-nom[2:ln]
     ln<-length(nom)
     }

lc<-sqrt(length(cor))
cor<-format(cor,digits=4)
    
write(c("             ",nom),ncolumns=ln+1,file=FOUT)
write(" ",file=FOUT)

for(i in 1:ln){
write(c(nom[i],"   ",cor[(lc*(i-1)+1):(lc*i)]),ncolumns=lc+2,file=FOUT)
write(" ",file=FOUT)
}

}
 
#------------------------------------------
#Affichage de l'indice de conditionnement |
#------------------------------------------

if(is.na(idc)==FALSE){

write("-----------------------------",file=FOUT)
write("| Indice de conditionnement |",file=FOUT)
write("-----------------------------",file=FOUT)
write(" ",file=FOUT)
write(c("idc :",idc),ncolumns=2,file=FOUT)
write(" ",file=FOUT)

}

}
