afficheloo<-function(x,y,FOUT,resultat){

#-----------------------------------------------------------------
#Fonction permettant d'afficher les resultats du leave-one-out   |
#                                                                |
#----------------------------------------------------------------|
#Arguments                                                       |
#obligatoires : x : matrice contenant les variables d'entree     |
#               y : matrice contenant la variable de sortie      |
#               FOUT : nom du fichier ou afficher les resultats  |
#               resultat : variable contenant les resultats de   |
#               la validation croisee                            |
#----------------------------------------------------------------|
#Sortie : la fonction affiche les resultats dans le fichier      |
#res-SURFER.out qui se trouve dans le repertoire de travail      |
#----------------------------------------------------------------|
#      Auteur : B. Iooss                                         |
#----------------------------------------------------------------|

write("--------------------------",file=FOUT)
write("| ---------------------- |",file=FOUT)
write("| |    Leave-one-out   | |",file=FOUT)
write("| ---------------------- |",file=FOUT)
write("--------------------------",file=FOUT)
write(" ",file=FOUT)

i<-1
ncr<-11 # nombre de criteres

#---------------------------------------
#Affichage de l'erreur d'apprentissage |
#---------------------------------------

write("------------------------------------------",file=FOUT)
write("| Estimation de l'erreur d'apprentissage |",file=FOUT)
write("------------------------------------------",file=FOUT)
write(" ",file=FOUT)

write("                                 Moyenne     Ecart-type     Minimum     Maximum",file=FOUT)
write(" ",file=FOUT)

write(c("R2                              ",resultat[i+1*ncr],resultat[i+7*ncr],resultat[i+3*ncr],resultat[i+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("R2 ajuste                       ",resultat[i+1+1*ncr],resultat[i+1+7*ncr],resultat[i+1+3*ncr],resultat[i+1+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MSE                             ",resultat[i+2+1*ncr],resultat[i+2+7*ncr],resultat[i+2+3*ncr],resultat[i+2+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("NMSE                            ",resultat[i+3+1*ncr],resultat[i+3+7*ncr],resultat[i+3+3*ncr],resultat[i+3+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("SMSE                            ",resultat[i+4+1*ncr],resultat[i+4+7*ncr],resultat[i+4+3*ncr],resultat[i+4+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MAE                             ",resultat[i+5+1*ncr],resultat[i+5+7*ncr],resultat[i+5+3*ncr],resultat[i+5+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais                           ",resultat[i+6+1*ncr],resultat[i+6+7*ncr],resultat[i+6+3*ncr],resultat[i+6+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais normalise                 ",resultat[i+7+1*ncr],resultat[i+7+7*ncr],resultat[i+7+3*ncr],resultat[i+7+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu maximal                  ",resultat[i+8+1*ncr],resultat[i+8+7*ncr],resultat[i+8+3*ncr],resultat[i+8+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en moyenne       ",resultat[i+9+1*ncr],resultat[i+9+7*ncr],resultat[i+9+3*ncr],resultat[i+9+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en ecart-type    ",resultat[i+10+1*ncr],resultat[i+10+7*ncr],resultat[i+10+3*ncr],resultat[i+10+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)

#-------------------------------------
#Affichage de l'erreur de prediction |
#-------------------------------------

write("----------------------------------------",file=FOUT)
write("| Estimation de l'erreur de prediction |",file=FOUT)
write("----------------------------------------",file=FOUT)
write(" ",file=FOUT)

write("                                 Moyenne",file=FOUT)
write(" ",file=FOUT)

write(c("Q2                         ",resultat[i]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("Q2 ajuste                       ",resultat[i+1]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("MSE                             ",resultat[i+2]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("NMSE                            ",resultat[i+3]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("SMSE                            ",resultat[i+4]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("MAE                             ",resultat[i+5]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("Biais                           ",resultat[i+6]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("Biais normalise                 ",resultat[i+7]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("Residu maximal                  ",resultat[i+8]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en moyenne       ",resultat[i+9]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en ecart-type    ",resultat[i+10]),ncolumns=2,file=FOUT)
write(" ",file=FOUT)

}
