affichevc<-function(x,y,FOUT,r,resultat,K){

#-----------------------------------------------------------------
#Fonction permettant d'afficher les resultats de la validation   |
#croisee                                                         |
#----------------------------------------------------------------|
#Arguments                                                       |
#obligatoires : x : matrice contenant les variables d'entree     |
#               y : matrice contenant la variable de sortie      |
#               FOUT : nom du fichier ou afficher les resultats  |
#               r : longueur de la variable resultat             |
#               resultat : variable contenant les resultats de   |
#               la validation croisee                            |
#               K : nombre de repetitions de la vc               |
#                 si K est ngatif, on intervertit les rles     |
#                 des bases de test et d'apprentissage           |
#----------------------------------------------------------------|
#Sortie : la fonction affiche les resultats dans le fichier      |
#res-SURFER.out qui se trouve dans le repertoire de travail      |
#----------------------------------------------------------------|
#      Auteur : A. Ducellier et B. Iooss                         |
#----------------------------------------------------------------|

write("--------------------------",file=FOUT)
write("| ---------------------- |",file=FOUT)
write("| | Validation croisee | |",file=FOUT)
write("| ---------------------- |",file=FOUT)
write("--------------------------",file=FOUT)
write(" ",file=FOUT)

# Verification des arguments
if(floor(abs(K)) <= 1){
write("N doit etre > 1",file=FOUT)
write("On prendra N=3 pour cet essai",file=FOUT)
write(" ",file=FOUT)
}

if(floor(abs(K)) > dim(x)[1]){
write("N doit etre inferieur au nombre d'observations",file=FOUT)
write("On prendra N=3 pour cet essai",file=FOUT)
write(" ",file=FOUT)
}

if(r==1){write(c("Il reste",resultat[1],"echantillons pour la validation croisee"),ncolumns=3,file=FOUT)
         write("Il faut reduire le nombre de coefficients dans la formule de regression pour pouvoir faire la validation croisee",file=FOUT)
         write(" ",file=FOUT)}
else{

write(c("Il reste",resultat[r],"echantillons pour la validation croisee"),ncolumns=3,file=FOUT)

write(" ",file=FOUT)

i<-1
ncr<-11 # nombre de criteres

#---------------------------------------
#Affichage de l'erreur d'apprentissage |
#---------------------------------------

write("------------------------------------------",file=FOUT)
write("| Estimation de l'erreur d'apprentissage |",file=FOUT)
write("------------------------------------------",file=FOUT)
write(" ",file=FOUT)

write("                                 Moyenne     Ecart-type     Minimum     Maximum",file=FOUT)
write(" ",file=FOUT)

write(c("R2                              ",resultat[i+1*ncr],resultat[i+7*ncr],resultat[i+3*ncr],resultat[i+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("R2 ajuste                       ",resultat[i+1+1*ncr],resultat[i+1+7*ncr],resultat[i+1+3*ncr],resultat[i+1+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MSE                             ",resultat[i+2+1*ncr],resultat[i+2+7*ncr],resultat[i+2+3*ncr],resultat[i+2+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("NMSE                            ",resultat[i+3+1*ncr],resultat[i+3+7*ncr],resultat[i+3+3*ncr],resultat[i+3+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("SMSE                            ",resultat[i+4+1*ncr],resultat[i+4+7*ncr],resultat[i+4+3*ncr],resultat[i+4+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MAE                             ",resultat[i+5+1*ncr],resultat[i+5+7*ncr],resultat[i+5+3*ncr],resultat[i+5+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais                           ",resultat[i+6+1*ncr],resultat[i+6+7*ncr],resultat[i+6+3*ncr],resultat[i+6+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais normalise                 ",resultat[i+7+1*ncr],resultat[i+7+7*ncr],resultat[i+7+3*ncr],resultat[i+7+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu maximal                  ",resultat[i+8+1*ncr],resultat[i+8+7*ncr],resultat[i+8+3*ncr],resultat[i+8+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en moyenne       ",resultat[i+9+1*ncr],resultat[i+9+7*ncr],resultat[i+9+3*ncr],resultat[i+9+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en ecart-type    ",resultat[i+10+1*ncr],resultat[i+10+7*ncr],resultat[i+10+3*ncr],resultat[i+10+5*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)

#-------------------------------------
#Affichage de l'erreur de prediction |
#-------------------------------------

write("----------------------------------------",file=FOUT)
write("| Estimation de l'erreur de prediction |",file=FOUT)
write("----------------------------------------",file=FOUT)
write(" ",file=FOUT)

write("                                 Moyenne     Ecart-type     Minimum     Maximum",file=FOUT)
write(" ",file=FOUT)

write(c("Q2                              ",resultat[i],resultat[i+6*ncr],resultat[i+2*ncr],resultat[i+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Q2 ajuste                       ",resultat[i+1],resultat[i+1+6*ncr],resultat[i+1+2*ncr],resultat[i+1+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MSE                             ",resultat[i+2],resultat[i+2+6*ncr],resultat[i+2+2*ncr],resultat[i+2+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("NMSE                            ",resultat[i+3],resultat[i+3+6*ncr],resultat[i+3+2*ncr],resultat[i+3+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("SMSE                            ",resultat[i+4],resultat[i+4+6*ncr],resultat[i+4+2*ncr],resultat[i+4+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("MAE                             ",resultat[i+5],resultat[i+5+6*ncr],resultat[i+5+2*ncr],resultat[i+5+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais                           ",resultat[i+6],resultat[i+6+6*ncr],resultat[i+6+2*ncr],resultat[i+6+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Biais normalise                 ",resultat[i+7],resultat[i+7+6*ncr],resultat[i+7+2*ncr],resultat[i+7+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu maximal                  ",resultat[i+8],resultat[i+8+6*ncr],resultat[i+8+2*ncr],resultat[i+8+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en moyenne       ",resultat[i+9],resultat[i+9+6*ncr],resultat[i+9+2*ncr],resultat[i+9+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)
write(c("Residu relatif en ecart-type    ",resultat[i+10],resultat[i+10+6*ncr],resultat[i+10+2*ncr],resultat[i+10+4*ncr]),ncolumns=5,file=FOUT)
write(" ",file=FOUT)

}}
