criteres<-function(yt,pred,dim_x){

#---------------------------------------------------------------
#Fonction calculant les criteres de qualite d'une              |
#regression : R2, R2 ajuste, MSE, NMSE, SMSE, MAE, biais,      |
#biais normalise, residu maximum, residu relatif en moyenne et |
#en ecart-type                                                 |
#--------------------------------------------------------------|
#Arguments                                                     |
#obligatoires : yt : valeurs observees                         |
#               pred : valeurs predites apres regression       |
#               dim_x : nombre de predicteurs (pour R2 ajuste) |
#--------------------------------------------------------------|
#Sortie : la fonction renvoie les criteres R2, R2 ajuste, MSE, | 
#         NMSE, SMSE, MAE, biais, biais normalise,             | 
#         residu max, residu relatif en moyenne et ecart-type  |
#--------------------------------------------------------------|
#      Auteur : B. Iooss et P-M. Pair                          |
#--------------------------------------------------------------|  
  
return(c(R2(yt,pred),R2ajuste(yt,pred,dim_x),MSE(yt,pred),NMSE(yt,pred),SMSE(yt,pred),MAE(yt,pred),biais(yt,pred),residus(yt,pred)))

}
