formuleWilks<-function(alpha=0.95,beta=0.95,bilateral=FALSE,ordre=1){

#--------------------------------------------------------------
#Calcule la taille minimale d'un chantillon  gnrer        |
#alatoirement  l'aide de la Formule de Wilks                |
#                                                             |
#-------------------------------------------------------------|
#Arguments                                                    |
#obligatoires : aplha : valeur du alpha pour l'intervalle     |
#                       de confiance (entre 0 et 1). Dfaut   |
# 	                  mis  0.95                            |
#               beta :  valeur du beta pour l'intervalle      |
#                       de tolrance (entre 0 et 1). Dfaut   |
# 	                  mis  0.95                            |
#               bilateral : TRUE si l'on veut un intervalle   |
#                       bilateral, FALSE par dfaut           |
#               ordre : ordre de la forumule de Wilks         |
#                       L'ordre par dfaut est 1              |
#-------------------------------------------------------------|
#Sortie : la valeur du N minimale                             |
#-------------------------------------------------------------|
#      Auteur : M. Kadiri et P. Lemaitre                      |
#-------------------------------------------------------------|

#traitement du cas uni ou bilateral : on double l'ordre si bilateral
if (bilateral=="TRUE")
 ordre=2*ordre

#on dtermine la formule de Wilks associe
FWilks <- function(N,alpha,beta,ordre){
	coef=matrix(NA,nrow=ordre)
	coef[1]=1
	if (ordre>=2){
		for (i in 2:ordre){
		coef[i]=coef[i-1]*(N-i+2)/factorial(i-1)*factorial(i-2)}}
	else {}

FWilks=1;
	for (i in 1:ordre){
	FWilks=FWilks-coef[i]*alpha^(N-i+1)*(1-alpha)^(i-1)}
FWilks=FWilks-beta
return (FWilks)
}

# a noter : la formule de Wilks prsente ainsi ne fonctionne que pour N de taille 1

nmax=1000
# cherche la borne max de l'intervalle de recherche de n, pour annuler Fwilks

if (ordre!=1) {
	while (FWilks(nmax,alpha,beta,ordre)<0) {nmax=nmax+100}
	nmin=nmax-1000+1

	# recherche du n tel que FWilks=0 par dichotomie
	sortie=10

	while (sortie>1) {
		n=ceiling((nmax+nmin)/2)
    		FWilksn=FWilks(n,alpha,beta,ordre)

    		if (FWilksn<0) {nmin=n}
    		if (FWilksn>0) {nmax=n}
    		if (FWilksn==0) {sortie=0}
    			
    		FWilksn_1=FWilks(n-1,alpha,beta,ordre)
    		FWilksnp1=FWilks(n+1,alpha,beta,ordre)
   
    		if (FWilksn_1<0 && FWilksn>0) {
        		if (abs(FWilksn)>abs(FWilksn_1)) {n=n-1}
         	      	sortie=0 
						}#end if

    		if (FWilksn<0 && FWilksnp1>0)    {
        		if (abs(FWilksn)>abs(FWilksnp1)) {n=n+1}
           	    	sortie=0
						}#end if
    
	}# end while

	} #end if

if (ordre==1) {n=ceiling(log(1-beta)/log(alpha))}

return (N=n)
}
