predictSR<-function(modele,x,methode=1){
#---------------------------------------------------------------------------|
#Fonction de prediction a partir de modele et methode sur une matrice       |
#---------------------------------------------------------------------------|
#Arguments                                                                  |
#obligatoires : modele : objet contenant le modele                          |
#               x : matrice de variables d'entree                           |
#                                                                           |
#Argument                                                                   |
#facultatif :                                                               |
#       methode : numero de la methode                                      |
#       1=GLM, 2=PLS, 3=SVM, 4=BOOSTING, 5=RF, 6=RN, 7=GAM, 8=PG, 9=PGdice  |
#---------------------------------------------------------------------------|
#Sortie : le vecteur prediction de modele(x)                                |
#---------------------------------------------------------------------------|
#      Auteur : B. Iooss                                                    |
#---------------------------------------------------------------------------|  

  if (methode==1 | methode==7) pred<-predict(modele,newdata=data.frame(x),type="response")
  else if (methode==2) pred<-predict(modele,data.frame(x),cumulative=FALSE,comps=modele$ncomp)
  else if (methode==4) pred<-predict(modele,x,n.trees=modele$n.trees) 
  else if (methode==9) pred<-predict.km(modele,data.frame(x),type="UK")$mean
  else pred<-predict(modele,x) # methodes 3 5 6 8

  return(pred)
}
