residus<-function(y,yp){

#-----------------------------------------------------------
#Fonction calculant les criteres de residu maximum (en     |
#valeur absolue) et de residu relatif en moyenne et        |
#ecart-type.                             	           |
#----------------------------------------------------------|
#Arguments                                                 |
#obligatoires : y : valeurs des donnees                    |
#               yp : valeurs predites                      |
#----------------------------------------------------------|
#Sortie : la fonction renvoie les criteres de residu       |
#         maximum et de residu relatif en moyenne et en    |
#         ecart-type                                       |
#----------------------------------------------------------|
#      Auteur : B. Iooss et P-M. Pair                      |
#----------------------------------------------------------|  

a=mean((y-yp)/y)
a[!is.finite(a)]=Inf
b=sqrt(var((y-yp)/y))
b[!is.finite(b)]=Inf

return(c(max(abs(y-yp)),a,b))

}
