select<-function(x,y,p=0.67){

#-------------------------------------------------------------------
# Cette fonction decoupe un echantillon (x,y)                      |
# en une base de test et une base d'apprentissage.                 |
#------------------------------------------------------------------- 
# Arguments: x,y : l'echantillon a decouper.                       |
#            p : Definit la proportion des bases. Si p=2/3,        |  
#                la base d'apprentissage prendra 2/3 des points.   | 
#-------------------------------------------------------------------
# Sorties: xa,ya : (variables globales) La base d'apprentissage.   |
#	   xt,yt : (variables globales) La base de test.	   |
#------------------------------------------------------------------|
#      Auteur : B. Iooss                                           |
#------------------------------------------------------------------|

	if ((p<=0)|(p>=1)){
		print("p doit appartenir a ]0,1[. On prendra 2/3 pour cet essai.")
		p<-0.67
	}

	alea<-runif(length(y))
	index<-(alea>p)

	xt<<-x[index,]
	xa<<-x[!index,]
	yt<<-y[index]
	ya<<-y[!index]
}
